# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['WebhookEndpointArgs', 'WebhookEndpoint']

@pulumi.input_type
class WebhookEndpointArgs:
    def __init__(__self__, *,
                 enabled_events: pulumi.Input[Sequence[pulumi.Input[str]]],
                 url: pulumi.Input[str],
                 api_version: Optional[pulumi.Input[str]] = None,
                 connect: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a WebhookEndpoint resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enabled_events: List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        :param pulumi.Input[str] url: String. The URL of the webhook endpoint.
        :param pulumi.Input[str] api_version: String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        :param pulumi.Input[bool] connect: Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        :param pulumi.Input[str] description: String. Description of what the webhook is used for.
        :param pulumi.Input[bool] disabled: Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        """
        pulumi.set(__self__, "enabled_events", enabled_events)
        pulumi.set(__self__, "url", url)
        if api_version is not None:
            pulumi.set(__self__, "api_version", api_version)
        if connect is not None:
            pulumi.set(__self__, "connect", connect)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disabled is not None:
            pulumi.set(__self__, "disabled", disabled)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)

    @property
    @pulumi.getter(name="enabledEvents")
    def enabled_events(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        """
        return pulumi.get(self, "enabled_events")

    @enabled_events.setter
    def enabled_events(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "enabled_events", value)

    @property
    @pulumi.getter
    def url(self) -> pulumi.Input[str]:
        """
        String. The URL of the webhook endpoint.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: pulumi.Input[str]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> Optional[pulumi.Input[str]]:
        """
        String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        """
        return pulumi.get(self, "api_version")

    @api_version.setter
    def api_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_version", value)

    @property
    @pulumi.getter
    def connect(self) -> Optional[pulumi.Input[bool]]:
        """
        Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        """
        return pulumi.get(self, "connect")

    @connect.setter
    def connect(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "connect", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        String. Description of what the webhook is used for.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def disabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        """
        return pulumi.get(self, "disabled")

    @disabled.setter
    def disabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "disabled", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)


@pulumi.input_type
class _WebhookEndpointState:
    def __init__(__self__, *,
                 api_version: Optional[pulumi.Input[str]] = None,
                 connect: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 enabled_events: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 secret: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering WebhookEndpoint resources.
        :param pulumi.Input[str] api_version: String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        :param pulumi.Input[bool] connect: Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        :param pulumi.Input[str] description: String. Description of what the webhook is used for.
        :param pulumi.Input[bool] disabled: Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enabled_events: List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        :param pulumi.Input[str] secret: String. The endpoint’s secret, used to generate webhook signatures. This field is marked as `sensitive`.
        :param pulumi.Input[str] url: String. The URL of the webhook endpoint.
        """
        if api_version is not None:
            pulumi.set(__self__, "api_version", api_version)
        if connect is not None:
            pulumi.set(__self__, "connect", connect)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if disabled is not None:
            pulumi.set(__self__, "disabled", disabled)
        if enabled_events is not None:
            pulumi.set(__self__, "enabled_events", enabled_events)
        if metadata is not None:
            pulumi.set(__self__, "metadata", metadata)
        if secret is not None:
            pulumi.set(__self__, "secret", secret)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> Optional[pulumi.Input[str]]:
        """
        String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        """
        return pulumi.get(self, "api_version")

    @api_version.setter
    def api_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_version", value)

    @property
    @pulumi.getter
    def connect(self) -> Optional[pulumi.Input[bool]]:
        """
        Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        """
        return pulumi.get(self, "connect")

    @connect.setter
    def connect(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "connect", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        String. Description of what the webhook is used for.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def disabled(self) -> Optional[pulumi.Input[bool]]:
        """
        Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        """
        return pulumi.get(self, "disabled")

    @disabled.setter
    def disabled(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "disabled", value)

    @property
    @pulumi.getter(name="enabledEvents")
    def enabled_events(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        """
        return pulumi.get(self, "enabled_events")

    @enabled_events.setter
    def enabled_events(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "enabled_events", value)

    @property
    @pulumi.getter
    def metadata(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        """
        return pulumi.get(self, "metadata")

    @metadata.setter
    def metadata(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "metadata", value)

    @property
    @pulumi.getter
    def secret(self) -> Optional[pulumi.Input[str]]:
        """
        String. The endpoint’s secret, used to generate webhook signatures. This field is marked as `sensitive`.
        """
        return pulumi.get(self, "secret")

    @secret.setter
    def secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "secret", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        String. The URL of the webhook endpoint.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


class WebhookEndpoint(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_version: Optional[pulumi.Input[str]] = None,
                 connect: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 enabled_events: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        With this resource, you can create a webhook endpoint - [Stripe API webhook endpoint documentation](https://stripe.com/docs/api/webhook_endpoints).

        You can configure webhook endpoints via the API to be notified about events that happen in your Stripe account or connected accounts.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_stripe as stripe

        webhook = stripe.WebhookEndpoint("webhook",
            description="example of webhook",
            enabled_events=[
                "customer.subscription.created",
                "customer.subscription.updated",
            ],
            url="https://webhook-url-consumer.com")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_version: String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        :param pulumi.Input[bool] connect: Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        :param pulumi.Input[str] description: String. Description of what the webhook is used for.
        :param pulumi.Input[bool] disabled: Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enabled_events: List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        :param pulumi.Input[str] url: String. The URL of the webhook endpoint.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WebhookEndpointArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        With this resource, you can create a webhook endpoint - [Stripe API webhook endpoint documentation](https://stripe.com/docs/api/webhook_endpoints).

        You can configure webhook endpoints via the API to be notified about events that happen in your Stripe account or connected accounts.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_stripe as stripe

        webhook = stripe.WebhookEndpoint("webhook",
            description="example of webhook",
            enabled_events=[
                "customer.subscription.created",
                "customer.subscription.updated",
            ],
            url="https://webhook-url-consumer.com")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param WebhookEndpointArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WebhookEndpointArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_version: Optional[pulumi.Input[str]] = None,
                 connect: Optional[pulumi.Input[bool]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 disabled: Optional[pulumi.Input[bool]] = None,
                 enabled_events: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WebhookEndpointArgs.__new__(WebhookEndpointArgs)

            __props__.__dict__["api_version"] = api_version
            __props__.__dict__["connect"] = connect
            __props__.__dict__["description"] = description
            __props__.__dict__["disabled"] = disabled
            if enabled_events is None and not opts.urn:
                raise TypeError("Missing required property 'enabled_events'")
            __props__.__dict__["enabled_events"] = enabled_events
            __props__.__dict__["metadata"] = metadata
            if url is None and not opts.urn:
                raise TypeError("Missing required property 'url'")
            __props__.__dict__["url"] = url
            __props__.__dict__["secret"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["secret"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(WebhookEndpoint, __self__).__init__(
            'stripe:index/webhookEndpoint:WebhookEndpoint',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            api_version: Optional[pulumi.Input[str]] = None,
            connect: Optional[pulumi.Input[bool]] = None,
            description: Optional[pulumi.Input[str]] = None,
            disabled: Optional[pulumi.Input[bool]] = None,
            enabled_events: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            metadata: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            secret: Optional[pulumi.Input[str]] = None,
            url: Optional[pulumi.Input[str]] = None) -> 'WebhookEndpoint':
        """
        Get an existing WebhookEndpoint resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_version: String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        :param pulumi.Input[bool] connect: Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        :param pulumi.Input[str] description: String. Description of what the webhook is used for.
        :param pulumi.Input[bool] disabled: Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enabled_events: List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] metadata: Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        :param pulumi.Input[str] secret: String. The endpoint’s secret, used to generate webhook signatures. This field is marked as `sensitive`.
        :param pulumi.Input[str] url: String. The URL of the webhook endpoint.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WebhookEndpointState.__new__(_WebhookEndpointState)

        __props__.__dict__["api_version"] = api_version
        __props__.__dict__["connect"] = connect
        __props__.__dict__["description"] = description
        __props__.__dict__["disabled"] = disabled
        __props__.__dict__["enabled_events"] = enabled_events
        __props__.__dict__["metadata"] = metadata
        __props__.__dict__["secret"] = secret
        __props__.__dict__["url"] = url
        return WebhookEndpoint(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="apiVersion")
    def api_version(self) -> pulumi.Output[Optional[str]]:
        """
        String. Events sent to this endpoint will be generated with this Stripe Version instead of your account’s default Stripe Version.
        """
        return pulumi.get(self, "api_version")

    @property
    @pulumi.getter
    def connect(self) -> pulumi.Output[Optional[bool]]:
        """
        Bool. Whether this endpoint should receive events from connected accounts (`true`), or from your account (`false`). Defaults to `false`.
        """
        return pulumi.get(self, "connect")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        String. Description of what the webhook is used for.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def disabled(self) -> pulumi.Output[Optional[bool]]:
        """
        Bool. Disable the webhook endpoint if set to `true`. Can be used only for modification already existing webhook endpoint.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter(name="enabledEvents")
    def enabled_events(self) -> pulumi.Output[Sequence[str]]:
        """
        List(String). The list of events to enable for this endpoint. `[*]` indicates that all events are enabled, except those that require explicit selection. All supported events listed here: [Stripe event types](https://stripe.com/docs/api/events/types).
        """
        return pulumi.get(self, "enabled_events")

    @property
    @pulumi.getter
    def metadata(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        Map(String). Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
        """
        return pulumi.get(self, "metadata")

    @property
    @pulumi.getter
    def secret(self) -> pulumi.Output[str]:
        """
        String. The endpoint’s secret, used to generate webhook signatures. This field is marked as `sensitive`.
        """
        return pulumi.get(self, "secret")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[str]:
        """
        String. The URL of the webhook endpoint.
        """
        return pulumi.get(self, "url")

